// RSESCIScanMeasurementDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSESCIScanMeasurement.h"
#include "RSESCIScanMeasurementDlg.h"
#include "rsesci.h"
#include "globals.h"
#include "resource.h"
#define  ARRAY_SIZE  100000

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int					g_Running;
CEvent				g_EventMeasurementStopped, g_EventStopMeasurement;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();


// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSESCIScanMeasurementDlg dialog

CRSESCIScanMeasurementDlg::CRSESCIScanMeasurementDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSESCIScanMeasurementDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSESCIScanMeasurementDlg)
	m_RessString	= _T("GPIB0::20::INSTR");
	m_Reset			= 0;
	m_Mode1			= 0;
	m_Mode2			= 0;
	m_Detector1		= 0;
	m_Detector2		= 3;
	m_Domain		= 0;
	m_Query			= 0;
	m_Count			= 0;


	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

void CRSESCIScanMeasurementDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSESCIScanMeasurementDlg)
	DDX_Control(pDX, IDC_START, m_Start);
	DDX_Control(pDX, IDC_ABORT, m_Abort);
	DDX_Control(pDX, IDC_MEAS_LABEL, m_Label);
	DDX_Text(pDX, IDC_RESOURCE_NAME, m_RessString);
	DDX_CBIndex(pDX, IDC_RESET, m_Reset);
	DDX_CBIndex(pDX, IDC_TRACE_MODE_1, m_Mode1);
	DDX_CBIndex(pDX, IDC_TRACE_MODE_2, m_Mode2);
	DDX_CBIndex(pDX, IDC_TRACE_DETECTOR_1, m_Detector1);
	DDX_CBIndex(pDX, IDC_TRACE_DETECTOR_2, m_Detector2);
	DDX_Control(pDX, IDC_GRAPH, m_Graph);
	DDX_CBIndex(pDX, IDC_DOMAIN, m_Domain);
	DDX_CBIndex(pDX, IDC_QUERY, m_Query);
	DDX_Text(pDX, IDC_COUNT, m_Count);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSESCIScanMeasurementDlg, CDialog)
	//{{AFX_MSG_MAP(CRSESCIScanMeasurementDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ABORT, OnAbort)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_MESSAGE(WM_USER, OnUserMessage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSESCIScanMeasurementDlg message handlers

BOOL CRSESCIScanMeasurementDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSESCIScanMeasurementDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSESCIScanMeasurementDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSESCIScanMeasurementDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSESCIScanMeasurementDlg::OnAbort() 
{
	if (g_Running)
	{
	
		g_EventStopMeasurement.SetEvent();
		do
		{
			Sleep (100);
		} while (::WaitForSingleObject(g_EventMeasurementStopped, 10));
	
		//UpdateData(false);
		
		g_Running = false;

		HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
	}	
}

void CRSESCIScanMeasurementDlg::OnStart() 
{
	char			buffer[512];
	ViInt32			sweep_spacing = RSESCI_LIN;
	unsigned short	auto_ranging = 0;
	ViStatus		rsesci_status;

	UpdateData();
	g_Running = true;

	switch (m_Detector1)
	{
		case 0: m_Detector1 = 1; //NEG
			break;
		case 1: m_Detector1 = 2; //POS
			break;
		case 2: m_Detector1 = 4; //RMS
			break;
		case 3: m_Detector1 = 5; //AVER
			break;
		default: m_Detector1 = 1;
	}
	switch (m_Detector2)
	{
		case 0: m_Detector2 = 1;
			break;
		case 1: m_Detector2 = 2;
			break;
		case 2: m_Detector2 = 4;
			break;
		case 3: m_Detector2 = 5;
			break;
		default: m_Detector2 = 1;
	}

	switch (m_Mode1)
	{
		case 0: m_Mode1 = 0; //WRITE
			break;
		case 1: m_Mode1 = 1; //VIEW
			break;
		case 2: m_Mode1 = 3; //MAXH
			break;
		case 3: m_Mode1 = 4; //MINH
			break;
		default: m_Mode1 = 1;
	}
	switch (m_Mode2)
	{
		case 0: m_Mode2 = 0;
			break;
		case 1: m_Mode2 = 1;
			break;
		case 2: m_Mode2 = 3;
			break;
		case 3: m_Mode2 = 4;
			break;
		default: m_Mode2 = 1;
	}

	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	rsesci_status = rsesci_init ((char *) ((LPCTSTR) m_RessString), m_Query, m_Reset, &m_InstrSession);
	if (rsesci_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}

	FT_CHECKERR (rsesci_SetDisplayUpdate(m_InstrSession, 1), "rsesci_SetDisplayUpdate");
	FT_CHECKERR (rsesci_SetInstrumentMode(m_InstrSession, 1), "rsesci_SetInstrumentMode"); //EMI Receiver
	FT_CHECKERR (rsesci_SetLevelAxisUnit(m_InstrSession, 1, 0), "rsesci_SetLevelAxisUnit"); // dBm

	if (m_Domain == 0)
	{
		//Freq

		m_Graph.Axes.Item("XAxis").FormatString = "k\"Hz\"";
		
		FT_CHECKERR (rsesci_SetFrequencyMode(m_InstrSession, 1, 1), "rsesci_SetFrequencyMode");
		FT_CHECKERR (rsesci_SetStartFrequency(m_InstrSession, 1, 150000.0), "rsesci_SetStartFrequency");
		FT_CHECKERR (rsesci_SetStopFrequency(m_InstrSession, 1, 1000000000.0), "rsesci_SetStopFrequency");
		FT_CHECKERR (rsesci_SetSweepSpacing(m_InstrSession, 1, 2), "rsesci_SetSweepSpacing");
	}
	else
	{
		//Time

		m_Graph.Axes.Item("XAxis").FormatString = "k\"s\"";

		FT_CHECKERR (rsesci_SetFrequencyMode(m_InstrSession, 1, 0), "rsesci_SetFrequencyMode");
		FT_CHECKERR (rsesci_SetScanTimeDomain(m_InstrSession, 100), "rsesci_SetScanTimeDomain");
		FT_CHECKERR (rsesci_SetCenterFrequency(m_InstrSession, 1, 1000000000.0), "rsesci_SetCenterFrequency");
		FT_CHECKERR (rsesci_SetSweepTime(m_InstrSession, 1, 0.005), "rsesci_SetSweepTime");
	}

	FT_CHECKERR (rsesci_SetTraceMode(m_InstrSession, 1, 1, m_Mode1), "rsesci_SetTraceMode 1");
	FT_CHECKERR (rsesci_SetTraceDetector(m_InstrSession, 1, 1, m_Detector1), "rsesci_SetTraceDetector 1");
	FT_CHECKERR (rsesci_SetTraceMode(m_InstrSession, 1, 2, m_Mode2), "rsesci_SetTraceMode 2");
	FT_CHECKERR (rsesci_SetTraceDetector(m_InstrSession, 1, 2, m_Detector2), "rsesci_SetTraceDetector 2");

	FT_CHECKERR (rsesci_SetScanRanges(m_InstrSession, 2), "rsesci_SetScanRanges");
	FT_CHECKERR (rsesci_SetScanStart(m_InstrSession, 1, 150000.0), "rsesci_SetScanStart");
	FT_CHECKERR (rsesci_SetScanStop(m_InstrSession, 1, 30000000.0), "rsesci_SetScanStop");
	FT_CHECKERR (rsesci_SetScanStart(m_InstrSession, 2, 30000000.0), "rsesci_SetScanStart");
	FT_CHECKERR (rsesci_SetScanStop(m_InstrSession, 2, 1000000000.0), "rsesci_SetScanStop");
	FT_CHECKERR (rsesci_GetSweepSpacing(m_InstrSession, 1, &sweep_spacing), "rsesci_GetSweepSpacing");

	if (sweep_spacing  != RSESCI_AUTO)
	{
		FT_CHECKERR (rsesci_SetScanStepSize(m_InstrSession, 1, 4000.0), "rsesci_SetScanStepSize");
		FT_CHECKERR (rsesci_SetScanStepSize(m_InstrSession, 2, 40000.0), "rsesci_SetScanStepSize");
	}

	FT_CHECKERR (rsesci_SetScanBandwidth(m_InstrSession, 1, 9000.0), "rsesci_SetScanBandwidth");
	FT_CHECKERR (rsesci_SetScanBandwidth(m_InstrSession, 2, 120000.0), "rsesci_SetScanBandwidth");
	FT_CHECKERR (rsesci_SetScanMeasurementTime(m_InstrSession, 1, 0.001), "rsesci_SetScanMeasurementTime");
	FT_CHECKERR (rsesci_SetScanMeasurementTime(m_InstrSession, 2, 0.0001), "rsesci_SetScanMeasurementTime");
	FT_CHECKERR (rsesci_SetScanAutoRanging(m_InstrSession, 1, 0), "rsesci_SetScanAutoRanging"); //Auto Ranging
	FT_CHECKERR (rsesci_SetScanAutoRanging(m_InstrSession, 2, 0), "rsesci_SetScanAutoRanging");	//Auto Ranging
	FT_CHECKERR (rsesci_SetScanRFAttenuation(m_InstrSession, 1, 10), "rsesci_SetScanRFAttenuation"); //Attenuation
	FT_CHECKERR (rsesci_SetScanRFAttenuation(m_InstrSession, 2, 10), "rsesci_SetScanRFAttenuation"); //Attenuation
	FT_CHECKERR (rsesci_SetScanPreamplifier(m_InstrSession, 1, 0), "rsesci_SetScanPreamplifier"); //Preamplifier State
	FT_CHECKERR (rsesci_SetScanPreamplifier(m_InstrSession, 2, 0), "rsesci_SetScanPreamplifier"); //Preamplifier State
	
	FT_CHECKERR (rsesci_GetScanAutoRanging(m_InstrSession, 1, &auto_ranging), "rsesci_GetScanAutoRanging");

	if (auto_ranging)
		FT_CHECKERR (rsesci_SetScanAutoPreamplifier(m_InstrSession, 1, 0), "rsesci_SetScanAutoPreamplifier"); //Preamplifier In Autoranging
	
	FT_CHECKERR (rsesci_GetScanAutoRanging(m_InstrSession, 2, &auto_ranging), "rsesci_GetScanAutoRanging");

	if (auto_ranging)
		FT_CHECKERR (rsesci_SetScanAutoPreamplifier(m_InstrSession, 2, 0), "rsesci_SetScanAutoPreamplifier"); //Preamplifier In Autoranging

	
	if (m_Domain == 0)
	{
        FT_CHECKERR (rsesci_GetStartFrequency(m_InstrSession, 1, &m_XStart), "rsesci_GetStartFrequency");
        FT_CHECKERR (rsesci_GetStopFrequency(m_InstrSession, 1, &m_XStop), "rsesci_GetStopFrequency");
	}

    else
	{
        FT_CHECKERR (rsesci_GetSweepTime(m_InstrSession, 1, &m_XStart), "rsesci_GetSweepTime");
        FT_CHECKERR (rsesci_GetScanTimeDomain(m_InstrSession, &m_XStop), "rsesci_GetScanTimeDomain");
	}
    

    // --- Single Scan
    FT_CHECKERR (rsesci_SetScanMode(m_InstrSession, 0), "rsesci_SetScanMode"); //RSESCI_SCAN_SING

    // ------ Prepare and Run Scan ------

    FT_CHECKERR (rsesci_SetTraceFeedControl(m_InstrSession, 1, 1), "rsesci_SetTraceFeedControl");
    FT_CHECKERR (rsesci_RunScan(m_InstrSession), "rsesci_RunScan");

	m_Graph.ClearData();
	m_Graph.Axes.Item("XAxis").AutoScale = false;
	m_Graph.Axes.Item("XAxis").SetMinMax(m_XStart, m_XStop);

	if (m_Domain == 0)
	{
        m_Graph.Axes.Item("XAxis").Log = true;
	}
    else
        m_Graph.Axes.Item("XAxis").Log = false;

	m_Label.ShowWindow (SW_SHOW);
	m_Abort.EnableWindow(true);
	m_Start.EnableWindow(false);
	m_Count = 0;
	m_ThreadData.instrSession = &m_InstrSession;
	m_ThreadData.view = (CDialog*) this;

	AfxBeginThread ( ScanLoop, &m_ThreadData , THREAD_PRIORITY_NORMAL);
}

LRESULT CRSESCIScanMeasurementDlg::OnUserMessage(WPARAM wParam, LPARAM lParam)
{
	if ( wParam == UPDATE )
	{
		UpdateData (FALSE);
		return TRUE;
	}
	
	if ( wParam == GRAPH )
	{
		if (m_Domain == 0)
		{
			m_Graph.Plots.Item("Plot1").ChartY(m_Vector1_1, m_xFirstIncrement);
			m_Graph.Plots.Item("Plot2").ChartY(m_Vector1_2, m_xFirstIncrement);
			m_Graph.Plots.Item("Plot1").ChartY(m_Vector2_1, m_xSecondIncrement);
			m_Graph.Plots.Item("Plot2").ChartY(m_Vector2_2, m_xSecondIncrement);
		}
		else
		{
			m_Graph.Plots.Item("Plot1").ChartY(m_Vector1_1, (m_XStop - m_XStart) / m_Count);
			m_Graph.Plots.Item("Plot2").ChartY(m_Vector1_2, (m_XStop - m_XStart) / m_Count);
		}
		return TRUE;
	}

	return FALSE;
}
