#include "stdafx.h"
#include "RSESCIScanMeasurement.h"
#include "RSESCIScanMeasurementDlg.h"
#include "rsesci.h"
#include "globals.h"
#include "resource.h"

#define ARRAY_SIZE 100000

UINT ScanLoop( LPVOID pParam )
{
	CNiReal64Vector				vector1, 
								vector2;
	TThreadData					*pdata = (TThreadData*) pParam;
	CRSESCIScanMeasurementDlg	*pview = (CRSESCIScanMeasurementDlg*) pdata->view;
		
	ViChar		error_message[512];
	ViStatus	rsesci_status;
	unsigned int run;

	char		buffer[512];

	ViInt32		traceStatus, 
				noofPoints, 
				points, 
				scan1points, 
				scan2points;

	double		*tempT1;
	double		*tempT2;
	double		*tempT3;

	

	ViReal64	*scan1tempT1;
	ViReal64	*scan1tempT2;
	ViReal64	*scan1tempT3;
	ViReal64	*scan2tempT1;
	ViReal64	*scan2tempT2;
	ViReal64	*scan2tempT3;
	ViChar		*tempStatusData;

	scan1tempT1 = (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	scan1tempT2 = (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	scan1tempT3 = (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	scan2tempT1 = (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	scan2tempT2 = (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	scan2tempT3 = (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	tempStatusData = (ViChar*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	tempT1		= (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	tempT2		= (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));
	tempT3		= (ViReal64*) malloc (ARRAY_SIZE * sizeof (ViReal64));

	points		= 0;
	noofPoints	= 0;
	traceStatus = 0x0;
	scan1points = 0;
	scan2points = 0;
	run			= true;
	g_Running	= true;
    
	do
	{
		if (!(traceStatus & 0x1000))
       	{
			Sleep (250);
			
			rsesci_status = rsesci_ReadScanMeasurement(*(pdata->instrSession), ARRAY_SIZE, &traceStatus, &noofPoints, tempStatusData, tempT1, tempT2, tempT3);
			
			if (rsesci_status == 0)
			{
				if ((traceStatus & 0x1) == 1)
				{

					memcpy ((scan1tempT1 + scan1points), tempT1, noofPoints * sizeof (scan1tempT1[0]));
	                memcpy ((scan1tempT2 + scan1points), tempT2, noofPoints * sizeof (scan1tempT2[0]));
		            memcpy ((scan1tempT3 + scan1points), tempT3, noofPoints * sizeof (scan1tempT3[0]));

					scan1points += noofPoints;
				}
				else
				{
					memcpy ((scan2tempT1 + scan2points), tempT1, noofPoints * sizeof (scan2tempT1[0]));
		            memcpy ((scan2tempT2 + scan2points), tempT2, noofPoints * sizeof (scan2tempT2[0]));
	                memcpy ((scan2tempT3 + scan2points), tempT3, noofPoints * sizeof (scan2tempT3[0]));

					scan2points += noofPoints;
				}

				points += noofPoints;
				pview->m_Count = points;
				
				pview->PostMessage(WM_USER,UPDATE,0);
			}
		}
		else
		{
			run = false;
		}
	}
	while ((run) && (::WaitForSingleObject(g_EventStopMeasurement, 50) != WAIT_OBJECT_0));
	
	pview->m_Label.ShowWindow (SW_HIDE);
	pview->m_Abort.EnableWindow(false);
	pview->m_Start.EnableWindow(true);
		
	
	if (pview->m_Domain == 0)
	{
		rsesci_status = rsesci_Abort(*(pdata->instrSession));
		if (rsesci_status < 0)
		{
			sprintf (buffer, "Error: %ld, %s", rsesci_status, error_message);
			AfxMessageBox ("Could not open session!", MB_OK);
		}
		Sleep (1000);
		rsesci_status = rsesci_GetScanStepSize(*(pdata->instrSession), 1, &pview->m_xFirstIncrement);
		if (rsesci_status != 0)
		{
			AfxMessageBox ("GetScanStepSize (xFirstIncrement!", MB_OK);
		}
		rsesci_status = rsesci_GetScanStepSize(*(pdata->instrSession), 2, &pview->m_xSecondIncrement);
		if (rsesci_status != 0)
		{
			AfxMessageBox ("GetScanStepSize (xSecondIncrement!", MB_OK);
		}

		pview->m_Vector1_1 = CNiReal64Vector(scan1points, scan1tempT1);
		pview->m_Vector1_2 = CNiReal64Vector(scan1points, scan1tempT2);
		pview->m_Vector2_1 = CNiReal64Vector(scan2points, scan2tempT1);
		pview->m_Vector2_2 = CNiReal64Vector(scan2points, scan2tempT2);
	}
	else
	{
		pview->m_Vector1_1 = CNiReal64Vector(scan1points, scan1tempT1);
		pview->m_Vector1_2 = CNiReal64Vector(scan1points, scan1tempT2);
	}
	pview->PostMessage(WM_USER, GRAPH, 0);

	HCURSOR cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor ( cur );
	
	free(scan1tempT1);
    free(scan1tempT2);
	free(scan1tempT3);
    free(scan2tempT1);
    free(scan2tempT2);
	free(scan2tempT3);
    free(tempStatusData);
	free(tempT1);
	free(tempT2);
	free(tempT3);

	//rsesci_close(*(pdata->instrSession));
	
	g_EventMeasurementStopped.SetEvent();
	g_Running = false;

	return true;
}